/******************************************************************************
** Az albbi program s informcik a Nemzeti Kutatsi Fejlesztsi Programok
** 2002. vi plyzatn a 2. sz. programban elfogadott NKFP-2/0017/2002 szm
** ,,Adatrosta - webtrhzak nagytmeg adatbzisainak elemzse adatbnyszati 
** s statisztikai eszkzk segtsgvel'' elnevezs projekt termke.
**
** A program a projekt folyamn feldolgozsra kerl naplllomnyok
** (web, access s mail) binris kdolst s tmrtst vgzi.
**
** A program s informcik az Adatrosta projekt konzorciumnak tulajdona.
** Engedly nlkli felhasznlsa tilos.
**
** Az Adatrosta projekt konzorcium tagjai:
** ELTE TTK Szmtgptudomnyi Tsz.
** BME Matematika Intzet
** MTA SZTAKI Informatikai Kutatlaboratrium
** Axelero Rt.
** econet.hu Rt.
**
** http://adatrosta.hu/
** email: info@adatrosta.hu
**
** (C) 2003. Minden jog fenntartva.
**
**
** This data and information are property of the "Data Riddle" consortium.
** Modification or use without permission is strictly prohibited.
**
** (C) 2003 All rights reserved.
**
** Author: RACZ Balazs, 2003.
**
******************************************************************************/

/*!
  \file   types.h
  \brief  Defines machine-dependent types.

  This header assures the easy portability of the program.
  All system-dependent types and functions should be declared here,
  like for example types with fixed width (uint32), endianness-converters.

  \author RACZ Balazs
  \date   2003-01-19
*/

#ifndef __MY_TYPES_H__
#define __MY_TYPES_H__ 

#include <inttypes.h>


#ifndef TYPENAME
#warning You should set -DTYPENAME=typename if using typename-enabled c++ compiler, otherwise set -DTYPENAME= 
#define TYPENAME
#endif

//! \brief 8-bit unsigned integer
typedef uint8_t uint8;

//! \brief 8-bit signed integer
typedef int8_t int8;



//! \brief 8-bit character
typedef unsigned char char8;


//! \brief Unicode character
//! wchar_t is a part of c++ standard
typedef wchar_t char16;


//! \brief 32-bit unsigned integer
typedef uint32_t uint32;


//! \brief 32-bit signed integer
typedef int32_t int32;

//! \brief 64-bit unsigned integer
typedef uint64_t uint64;

//! \brief 64-bit signed integer
typedef int64_t int64;


#include <sys/types.h>  //looks like cygwin doesn't like netinet.h without types.h
#ifndef __MINGW32__
#include <netinet/in.h>
#else
#include <winsock.h>
#endif

inline uint32 hton_u32(uint32 d) {
  //! \brief converts an uint32 from host byte order to standard byte order.
  return htonl(d); 
}

inline uint32 ntoh_u32(uint32 d) {
  //! \brief converts an uint32 from standard byte order to host byte order
  return htonl(d);
}

inline int32 hton_i32(int32 d) {
  //! \brief converts an int32 from host byte order to standard byte order.
  return htonl(d); 
}

inline int32 ntoh_i32(int32 d) {
  //! \brief converts an int32 from standard byte order to host byte order
  return htonl(d);
}


#endif //__MY_TYPES_H__
